#!/bin/sh

##########################################################################
#Script name: grid_chooser.sh                                            # 
#Developed for: MotoZINE ZN5 & for best Motorola fans forum - motofan.ru #
#Write by: AnarH                                                         #
#thanks for: TiM_22R.                                                    #
##########################################################################

######################################
#                Var                 #
######################################

mypath=${0%/*}
PATH=$PATH:$mypath

GRID_STD_LIB=/usr/SYSqtapp/xe/resource/skins/default
GRID_LIB=$mypath/grids

GRD=$GRID_STD_LIB/mainmenu/grid/grid.svg
TAB=$GRID_STD_LIB/mainmenu/tabs/tabs.svg

LST_STD_LIB=$GRID_STD_LIB/mainmenu/list

IL_STD=$LST_STD_LIB/iconList.svg
ILR_STD=$LST_STD_LIB/iconListReorder.svg
L_STD=$LST_STD_LIB/list.svg
LR_STD=$LST_STD_LIB/listReorder.svg

LST_LIB=$GRID_LIB/list

IL=$LST_LIB/iconList.svg
ILR=$LST_LIB/iconListReorder.svg
L=$LST_LIB/list.svg
LR=$LST_LIB/listReorder.svg


MM_STD=$GRID_STD_LIB/mainmenu/mainmenu.css
MM=$GRID_LIB/mainmenu.css

FORM=$GRID_LIB/form.svg
FORM_STD=$GRID_STD_LIB/form/form.svg

GRD12=$GRID_LIB/grids/grid_12_s.svg
GRD15=$GRID_LIB/grids/grid_15_s.svg
GRD18=$GRID_LIB/grids/grid_18_s.svg

GRD9PS=$GRID_LIB/grids/grid_9_pulse.svg
GRD12PS=$GRID_LIB/grids/grid_12_pulse.svg
GRD15PS=$GRID_LIB/grids/grid_15_pulse.svg
GRD18PS=$GRID_LIB/grids/grid_18_pulse.svg

GRD9ANI=$GRID_LIB/grids/grid_9_ani.svg
GRD12ANI=$GRID_LIB/grids/grid_12_ani.svg
GRD15ANI=$GRID_LIB/grids/grid_15_ani.svg
GRD18ANI=$GRID_LIB/grids/grid_18_ani.svg

TAB12=$GRID_LIB/tabs/tabs_12.svg
TAB15=$GRID_LIB/tabs/tabs_15.svg
TAB18=$GRID_LIB/tabs/tabs_18.svg

UMTSTD=$GRID_LIB/UMT/UserMenuTree_STD
UMT12=$GRID_LIB/UMT/UserMenuTree_12
UMT15=$GRID_LIB/UMT/UserMenuTree_15
UMT18=$GRID_LIB/UMT/UserMenuTree_18
UMT=/ezxlocal/download/appwrite/am/UserMenuTree 
UMTBKP=$GRID_LIB/BackUp/UserMenuTree_BKP

GRDSTD_INST=$GRID_LIB/Checker/GridSTD_installed
GRDSTD_INST_PS=$GRID_LIB/Checker/GridSTD_installed_PS
GRDSTD_INST_ANI=$GRID_LIB/Checker/GridSTD_installed_ANI

GRD12_INST=$GRID_LIB/Checker/Grid12_installed
GRD12_INST_PS=$GRID_LIB/Checker/Grid12_installed_PS
GRD12_INST_ANI=$GRID_LIB/Checker/Grid12_installed_ANI

GRD15_INST=$GRID_LIB/Checker/Grid15_installed
GRD15_INST_PS=$GRID_LIB/Checker/Grid15_installed_PS
GRD15_INST_ANI=$GRID_LIB/Checker/Grid15_installed_ANI

GRD18_INST=$GRID_LIB/Checker/Grid18_installed
GRD18_INST_PS=$GRID_LIB/Checker/Grid18_installed_PS
GRD18_INST_ANI=$GRID_LIB/Checker/Grid18_installed_ANI

ATR_ERROR=$GRID_LIB/autorun_error
ATR_CHK=$mypath/grid_chek.sh

export DIRNAME=`busybox dirname "$0"`


#######################################
#             Procedures              #
#######################################

############Cheking#GRID_LIB###########

ERROR_SEARCH () {

if [ ! -d $GRID_LIB/grids ]
  then
    ERROR_SHOW
fi

if [ ! -d $GRID_LIB/tabs ]
  then
    ERROR_SHOW
fi

if [ ! -d $GRID_LIB/UMT ]
  then
    ERROR_SHOW
fi

if [ ! -f $MM ]
  then
    ERROR_SHOW
fi

if [ ! -f $FORM ]
  then
    ERROR_SHOW
fi

if [ ! -d $LST_LIB ]
  then
    ERROR_SHOW
fi

}

##########Error#Show#Procedure##########

ERROR_SHOW () {
  showNotify "Ошибка" "Некоторый фалы, нужные для выполнения скрипта, отсутствуют. Скрипт не будет выполнен!!!" 2 6
  exit
}

########restore#BackUp#procedure########

restoreBKP () {

    showMsg "Восстановление" "Будет выполнено восстановление состояния меню (до первого запуска скрипта). Выполнить?" 1
    if [ $? != 0 ]
      then 

        Checker

        umount -f $GRD
        umount -f $TAB
        umount -f $MM_STD
        umount -f $FORM_STD
        umount -f $IL_STD
        umount -f $ILR_STD
        umount -f $L_STD
        umount -f $LR_STD

        cp $UMTBKP $UMT

        busybox killall flowplayer

        showNotify "Информация" "Восстановление выполнено!" 1 3
      else
        exec "$0"
    fi

}

#####Checking#which#Grid#installed######

Checker () {

#   #### Grid 12   

    if [ -f $GRD12_INST ]
      then
         cp $UMT $UMT12
         rm $GRD12_INST
    fi

    if [ -f $GRD12_INST_PS ]
      then
         cp $UMT $UMT12
         rm $GRD12_INST_PS
    fi

    if [ -f $GRD12_INST_ANI ]
      then
         cp $UMT $UMT12
         rm $GRD12_INST_ANI
    fi

#   #### Grid 15

    if [ -f $GRD15_INST ]
      then
         cp $UMT $UMT15
         rm $GRD15_INST
    fi

    if [ -f $GRD15_INST_PS ]
      then
         cp $UMT $UMT15
         rm $GRD15_INST_PS
    fi

    if [ -f $GRD15_INST_ANI ]
      then
         cp $UMT $UMT15
         rm $GRD15_INST_ANI
    fi

#   #### Grid 18

    if [ -f $GRD18_INST ]
      then
         cp $UMT $UMT18
         rm $GRD18_INST
    fi

    if [ -f $GRD18_INST_PS ]
      then
         cp $UMT $UMT18
         rm $GRD18_INST_PS
    fi

    if [ -f $GRD18_INST_ANI ]
      then
         cp $UMT $UMT18
         rm $GRD18_INST_ANI
    fi

#   #### Grid STD

    if [ -f $GRDSTD_INST ]
      then
         cp $UMT $UMTSTD
         rm $GRDSTD_INST
    fi

    if [ -f $GRDSTD_INST_PS ]
      then
         cp $UMT $UMTSTD
         rm $GRDSTD_INST_PS
    fi

    if [ -f $GRDSTD_INST_ANI ]
      then
         cp $UMT $UMTSTD
         rm $GRDSTD_INST_ANI
    fi

}

#################Reseter################

Reseter () {

  #check
   Checker
  #reset to default
   umount -f $GRD
   umount -f $TAB

}

################Updater#################

update () {

    showMsg "Обновление" "Будет выполнено обновление состояния меню (до использования режима соединения - карта памяти). Выполнить?" 1
    if [ $? != 0 ]
      then 
        /bin/sh $ATR_CHK
        busybox killall flowplayer
        showNotify "Выполнено" "Было выполнено обновление сетки меню (до использование режима соединения - карта памяти)" 1 4
      else
        exec "$0"
    fi
}

##########Choose#Grid#procedure#########

tuning () {

  showRadio "Изменение сетки меню" "Выберите количество пунктов меню:" "12 пунктов (3х4)" "15 пунктов (3х5)" "18 пунктов (3х6)" "Стандарт (3х3)"  
  RADIORES=$?
  if [ $RADIORES -eq 0 ]
      then
          exec "$0"

# ######### 12 icons BEGIN #############

    elif [ $RADIORES -eq 1 ] 
      then 
        showRadio "Выбор стиля анимации главного меню" "" "Пульсация" "Мягкая пульсация" "Без анимации"
        STYLE=$?

            if [ $STYLE -eq 0 ]
              then
                exec "$0"

## ############################ Pulse 12

              elif [ $STYLE -eq 1 ]
                then
                  Reseter
                  #apply 12 pulse icons
                   mount -o bind $GRD12PS $GRD
                   mount -o bind $TAB12 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT12 $UMT 

                  #Flag creator
                   touch $GRD12_INST_PS
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 12 пунктов (3х4). Анимация - Пульсация" 1 3

## ############################# Soft 12

              elif [ $STYLE -eq 2 ]
                then
                  Reseter
                  #apply 12 ani icons
                   mount -o bind $GRD12ANI $GRD
                   mount -o bind $TAB12 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT12 $UMT 

                   #Flag creator
                   touch $GRD12_INST_ANI
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 12 пунктов (3х4). Анимация - Мягкая пульcация" 1 5

## ############################# STD 12

              elif [ $STYLE -eq 3 ]
                then
                  Reseter
                  #apply 12 std icons
                   mount -o bind $GRD12 $GRD
                   mount -o bind $TAB12 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT12 $UMT 

                  #Flag creator
                   touch $GRD12_INST
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 12 пунктов (3х4). Анимация - отсутствует" 1 5
            fi

# ######### 12 icons END ##############

# ######### 15 icons BEGIN #############

    elif [ $RADIORES -eq 2 ] 
      then 
        showRadio "Выбор стиля анимации главного меню" "" "Пульсация" "Мягкая пульсация" "Без анимации"
        STYLE=$?

            if [ $STYLE -eq 0 ]
              then
                exec "$0"

## ############################ Pulse 15

              elif [ $STYLE -eq 1 ]
                then
                  Reseter
                  #apply 15 pulse icons
                   mount -o bind $GRD15PS $GRD
                   mount -o bind $TAB15 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT15 $UMT 

                  #Flag creator
                   touch $GRD15_INST_PS
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 15 пунктов (3х5). Анимация - Пульсация" 1 3

## ############################# Soft 15

              elif [ $STYLE -eq 2 ]
                then
                  Reseter
                  #apply 15 aniicons
                   mount -o bind $GRD15ANI $GRD
                   mount -o bind $TAB15 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT15 $UMT 

                  #Flag creator
                   touch $GRD15_INST_ANI
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 15 пунктов (3х5). Анимация - Мягкая пульсация" 1 5

## ############################# STD 15

              elif [ $STYLE -eq 3 ]
                then
                  Reseter
                  #apply 15 std icons
                   mount -o bind $GRD15 $GRD
                   mount -o bind $TAB15 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT15 $UMT 

                  #Flag creator
                   touch $GRD15_INST
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 15 пунктов (3х5). Анимация - отсутствует" 1 5
            fi

# ######### 15 icons END ##############

# ######### 18 icons BEGIN #############

    elif [ $RADIORES -eq 3 ] 
      then 
        showRadio "Выбор стиля анимации главного меню" "" "Пульсация" "Мягкая пульсация" "Без анимации"
        STYLE=$?

            if [ $STYLE -eq 0 ]
              then
                exec "$0"

## ############################ Pulse 18

              elif [ $STYLE -eq 1 ]
                then
                  Reseter
                  #apply 18 pulse icons
                   mount -o bind $GRD18PS $GRD
                   mount -o bind $TAB18 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT18 $UMT 

                  #Flag creator
                   touch $GRD18_INST_PS
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 18 пунктов (3х6). Анимация - Пульсация" 1 3

## ############################# Soft 18

              elif [ $STYLE -eq 2 ]
                then
                  Reseter
                  #apply 18 ani icons
                   mount -o bind $GRD18ANI $GRD
                   mount -o bind $TAB18 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT18 $UMT 

                  #Flag creator
                   touch $GRD18_INST_ANI
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 18 пунктов (3х6). Анимация - Мягкая пульсация" 1 5

## ############################# STD 18

              elif [ $STYLE -eq 3 ]
                then
                  Reseter
                  #apply 18 std icons
                   mount -o bind $GRD18 $GRD
                   mount -o bind $TAB18 $TAB
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMT18 $UMT 

                  #Flag creator
                   touch $GRD18_INST
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в режимен 18 пунктов (3х6). Анимация - отсутствует" 1 5
            fi

# ######### 18 icons END ##############

# ######### STD icons BEGIN ############

    elif [ $RADIORES -eq 4 ] 
      then 
        showRadio "Выбор стиля анимации главного меню" "" "Пульсация" "Мягкая пульсация" "Без анимации"
        STYLE=$?

            if [ $STYLE -eq 0 ]
              then
                exec "$0"

## ############################ Pulse STD

              elif [ $STYLE -eq 1 ]
                then
                  Reseter
                  #apply STD pulse icons
                   mount -o bind $GRD9PS $GRD
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMTSTD $UMT 

                  #Flag creator
                   touch $GRDSTD_INST_PS
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в стандартном режиме сетки (3х3). Анимация - Пульсация" 1 3

## ############################# Soft STD

              elif [ $STYLE -eq 2 ]
                then
                  Reseter
                  #apply STD ani icons
                   mount -o bind $GRD9ANI $GRD
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMTSTD $UMT 

                  #Flag creator
                   touch $GRDSTD_INST_ANI
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в стандартном режиме сетки (3х3). Анимация - Мягкая пульсация" 1 5

## ############################# STD STD

              elif [ $STYLE -eq 3 ]
                then
                  Reseter
                  #apply STD std icons
                   mount -o bind $MM $MM_STD 
                   mount -o bind $FORM $FORM_STD

                   mount -o bind $IL $IL_STD
                   mount -o bind $ILR $ILR_STD
                   mount -o bind $L $L_STD
                   mount -o bind $LR $LR_STD

                   cp $UMTSTD $UMT 

                  #Flag creator
                   touch $GRDSTD_INST
                  #flowplayer kill
                   busybox killall flowplayer
                  showNotify "Выполнено" "Главное меню работает в стандартном режиме сетки (3х3). Анимация - отсутствует" 1 5
            fi

   fi

# ######### STD icons END ##############

}


#########################################
#             Main body                 #
#########################################



############Creating#folders#############

if [ ! -d $GRID_LIB/BackUp ]
  then
    mkdir $GRID_LIB/BackUp
fi

if [ ! -d $GRID_LIB/Checker ]
  then
    mkdir $GRID_LIB/Checker
fi

#############BackUp#Creator##############

if [ ! -f $UMTBKP ]
  then
    umount -f $UMT
    cp $UMT $UMTBKP 
    showMsg "Информация" "Создается резервная копия стандартного расположения пунктов главного меню. Чтобы восстановить стандартные параматеры, выберите пункт Восстановить" 2
fi

##########Creating#standart#UMT##########

if [ ! -f $UMTSTD ]
  then
    cp $UMTBKP $UMTSTD
fi

################Starter##################

if [ -f $ATR_ERROR ]
  then
    showNotify "Ошибка" "Во время загрузки телефона (выполнения скрипта), была обнаружена ошибка. Не были найдены ключевые файлы для запуска скрипта!!!" 2 7
    rm $ATR_ERROR
fi

ERROR_SEARCH

showRadio "Вид главного меню" "Выберите действие над главным меню:" "Изменение сетки" "Обновить (карта памяти)" "Восстановить"
MENU=$?

  if [ $MENU -eq 0 ]
      then
        exit

    elif [ $MENU -eq 1 ] 
      then
        tuning

    elif [ $MENU -eq 2 ] 
      then      
        update  

    elif [ $MENU -eq 3 ] 
      then      
        restoreBKP  
  fi

###################End###################

