#!/bin/sh

##########################################################################
#Script name: atr_chek, added to grid_chooser                            #
#Developed for: MotoZINE ZN5 & for best Motorola fans forum - motofan.ru #
#Write by: AnarH                                                         #
#thanks for: TiM_22R.                                                    #
##########################################################################

######################################
#                Var                 #
######################################

mypath=${0%/*}
PATH=$PATH:$mypath

GRID_STD_LIB=/usr/SYSqtapp/xe/resource/skins/default
GRID_LIB=$mypath/grids

GRD=$GRID_STD_LIB/mainmenu/grid/grid.svg
TAB=$GRID_STD_LIB/mainmenu/tabs/tabs.svg

LST_STD_LIB=$GRID_STD_LIB/mainmenu/list

IL_STD=$LST_STD_LIB/iconList.svg
ILR_STD=$LST_STD_LIB/iconListReorder.svg
L_STD=$LST_STD_LIB/list.svg
LR_STD=$LST_STD_LIB/listReorder.svg

LST_LIB=$GRID_LIB/list

IL=$LST_LIB/iconList.svg
ILR=$LST_LIB/iconListReorder.svg
L=$LST_LIB/list.svg
LR=$LST_LIB/listReorder.svg


MM_STD=$GRID_STD_LIB/mainmenu/mainmenu.css
MM=$GRID_LIB/mainmenu.css

FORM=$GRID_LIB/form.svg
FORM_STD=$GRID_STD_LIB/form/form.svg

GRD12=$GRID_LIB/grids/grid_12_s.svg
GRD15=$GRID_LIB/grids/grid_15_s.svg
GRD18=$GRID_LIB/grids/grid_18_s.svg

GRD9PS=$GRID_LIB/grids/grid_9_pulse.svg
GRD12PS=$GRID_LIB/grids/grid_12_pulse.svg
GRD15PS=$GRID_LIB/grids/grid_15_pulse.svg
GRD18PS=$GRID_LIB/grids/grid_18_pulse.svg

GRD9ANI=$GRID_LIB/grids/grid_9_ani.svg
GRD12ANI=$GRID_LIB/grids/grid_12_ani.svg
GRD15ANI=$GRID_LIB/grids/grid_15_ani.svg
GRD18ANI=$GRID_LIB/grids/grid_18_ani.svg

TAB12=$GRID_LIB/tabs/tabs_12.svg
TAB15=$GRID_LIB/tabs/tabs_15.svg
TAB18=$GRID_LIB/tabs/tabs_18.svg

GRDSTD_INST=$GRID_LIB/Checker/GridSTD_installed
GRDSTD_INST_PS=$GRID_LIB/Checker/GridSTD_installed_PS
GRDSTD_INST_ANI=$GRID_LIB/Checker/GridSTD_installed_ANI

GRD12_INST=$GRID_LIB/Checker/Grid12_installed
GRD12_INST_PS=$GRID_LIB/Checker/Grid12_installed_PS
GRD12_INST_ANI=$GRID_LIB/Checker/Grid12_installed_ANI

GRD15_INST=$GRID_LIB/Checker/Grid15_installed
GRD15_INST_PS=$GRID_LIB/Checker/Grid15_installed_PS
GRD15_INST_ANI=$GRID_LIB/Checker/Grid15_installed_ANI

GRD18_INST=$GRID_LIB/Checker/Grid18_installed
GRD18_INST_PS=$GRID_LIB/Checker/Grid18_installed_PS
GRD18_INST_ANI=$GRID_LIB/Checker/Grid18_installed_ANI

ATR_ERROR=$GRID_LIB/autorun_error



#######################################
#             Procedures              #
#######################################


############Cheking#GRID_LIB###########



if [ ! -d $GRID_LIB/grids ]
  then
    touch $ATR_ERROR
fi

if [ ! -d $GRID_LIB/tabs ]
  then
    touch $ATR_ERROR
fi

if [ ! -d $GRID_LIB/UMT ]
  then
    touch $ATR_ERROR
fi

if [ ! -d $GRID_LIB/Checker ]
  then
    touch $ATR_ERROR
fi

if [ ! -f $MM ]
  then
    touch $ATR_ERROR
fi

if [ ! -f $FORM ]
  then
    touch $ATR_ERROR
fi

if [ ! -d $LST_LIB ]
  then
    touch $ATR_ERROR
fi




#####Checking#which#Grid#installed######

    if [ -f $GRD12_INST ]
      then

            mount -o bind $GRD12 $GRD
            mount -o bind $TAB12 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD12_INST_PS ]
      then

            mount -o bind $GRD12PS $GRD
            mount -o bind $TAB12 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD12_INST_ANI ]
      then

            mount -o bind $GRD12ANI $GRD
            mount -o bind $TAB12 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD15_INST ]
      then

            mount -o bind $GRD15 $GRD
            mount -o bind $TAB15 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD15_INST_PS ]
      then

            mount -o bind $GRD15PS $GRD
            mount -o bind $TAB15 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD15_INST_ANI ]
      then

            mount -o bind $GRD15ANI $GRD
            mount -o bind $TAB15 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD18_INST ]
      then

            mount -o bind $GRD18 $GRD
            mount -o bind $TAB18 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
             
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRD18_INST_PS ]
      then

            mount -o bind $GRD18PS $GRD
            mount -o bind $TAB18 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
             
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi


    if [ -f $GRD18_INST_ANI ]
      then

            mount -o bind $GRD18ANI $GRD
            mount -o bind $TAB18 $TAB
            mount -o bind $MM $MM_STD
            mount -o bind $FORM $FORM_STD
            
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRDSTD_INST ]
      then
          
            mount -o bind $FORM $FORM_STD
            mount -o bind $MM $MM_STD
             
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRDSTD_INST_PS ]
      then
 
            mount -o bind $GRD9PS $GRD
            mount -o bind $FORM $FORM_STD
            mount -o bind $MM $MM_STD
             
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD

    fi

    if [ -f $GRDSTD_INST_ANI ]
      then         

            mount -o bind $GRD9ANI $GRD
            mount -o bind $FORM $FORM_STD
            mount -o bind $MM $MM_STD
             
            mount -o bind $IL $IL_STD
            mount -o bind $ILR $ILR_STD
            mount -o bind $L $L_STD
            mount -o bind $LR $LR_STD
         
    fi


###################End###################

